#include "ti86asm.inc"

leftsave        = _textShadow
upsave          = _textShadow + 24
footsave        = _textShadow + 48
downsave        = _textShadow + 72
rightsave       = _textShadow + 96
score           = _textShadow + 120
tempbyte        = _textShadow + 122
delay           = _textShadow + 123
exitz           = _textShadow + 124
tempword1       = _textShadow + 125
tempword2       = _textShadow + 127
beat            = _textShadow + 129
tempbyte2       = _textShadow + 131
leftcheatflag   = _textShadow + 132
upcheatflag     = _textShadow + 133
footcheatflag   = _textShadow + 134
downcheatflag   = _textShadow + 135
rightcheatflag  = _textShadow + 136

.org _asm_exec_ram

    nop
    jp ProgStart
    .dw 0
    .dw ShellTitle

ShellTitle:
    .db "DDC version .35 by Garam Song",0

ProgStart:
 call ddcinit
 ld a,(exitz)\ or a\ jp nz,exit\ xor a\ ld (exitz),a

keyloop:
 ld a,%10111111
 out (1),a
 in a,(1)
 bit 6,a
 jp z,exitback
 call dofoot
 ld a,%11111110
 out (1),a
 in a,(1)
 ld (tempbyte2),a
 call doup
 call doright
 call dodown
 call doleft

nokey:
 call dolevel
 call incbeat
 call moveall
 call copytoscreen
 call wait
 jr keyloop

;----Calls----;
dolevel:
 ld hl,(beat)\ ld de,4\ call _cphlde\ call z,createright
 ld hl,(beat)\ ld de,14\ call _cphlde\ call z,createright
 ld hl,(beat)\ ld de,24\ call _cphlde\ call z,createleft
 ld hl,(beat)\ ld de,29\ call _cphlde\ call z,createleft
 ld hl,(beat)\ ld de,34\ call _cphlde\ call z,createleft
 ld hl,(beat)\ ld de,44\ call _cphlde\ call z,createdown
 ld hl,(beat)\ ld de,54\ call _cphlde\ call z,createdown
 ld hl,(beat)\ ld de,59\ call _cphlde\ call z,createup
 ld hl,(beat)\ ld de,64\ call _cphlde\ call z,createright
 ld hl,(beat)\ ld de,74\ call _cphlde\ call z,createright
 ld hl,(beat)\ ld de,84\ call _cphlde\ call z,createup
 ld hl,(beat)\ ld de,89\ call _cphlde\ call z,createright
 ld hl,(beat)\ ld de,94\ call _cphlde\ call z,createup
 ld hl,(beat)\ ld de,104\ call _cphlde\ call z,createleft
 ld hl,(beat)\ ld de,109\ call _cphlde\ call z,createup
 ld hl,(beat)\ ld de,114\ call _cphlde\ call z,createright
 ld hl,(beat)\ ld de,119\ call _cphlde\ call z,createleft
 ld hl,(beat)\ ld de,124\ call _cphlde\ call z,createup
 ld hl,(beat)\ ld de,134\ call _cphlde\ call z,createright
 ld hl,(beat)\ ld de,144\ call _cphlde\ call z,createup
 ld hl,(beat)\ ld de,154\ call _cphlde\ call z,createdown
 ld hl,(beat)\ ld de,154\ call _cphlde\ call z,createup
 ld hl,(beat)\ ld de,164\ call _cphlde\ call z,createleft
 ld hl,(beat)\ ld de,164\ call _cphlde\ call z,createright
 ld hl,(beat)\ ld de,174\ call _cphlde\ call z,createleft
 ld hl,(beat)\ ld de,174\ call _cphlde\ call z,createup
 ld hl,(beat)\ ld de,179\ call _cphlde\ call z,createup
 ld hl,(beat)\ ld de,184\ call _cphlde\ call z,createup
 ld hl,(beat)\ ld de,199\ call _cphlde\ call z,createleft
 ld hl,(beat)\ ld de,204\ call _cphlde\ call z,createup
 ld hl,(beat)\ ld de,209\ call _cphlde\ call z,createdown
 ld hl,(beat)\ ld de,214\ call _cphlde\ call z,createright
 ld hl,(beat)\ ld de,219\ call _cphlde\ call z,createup
 ld hl,(beat)\ ld de,254\ call _cphlde\ call z,createleft
 ld hl,(beat)\ ld de,274\ call _cphlde\ call z,createright
 ld hl,(beat)\ ld de,294\ call _cphlde\ call z,createdown
 ld hl,(beat)\ ld de,314\ call _cphlde\ call z,createup
 ld hl,(beat)\ ld de,324\ call _cphlde\ call z,createfoot
 ld hl,(beat)\ ld de,334\ call _cphlde\ call z,createleft
 ld hl,(beat)\ ld de,354\ call _cphlde\ call z,createright
 ld hl,(beat)\ ld de,374\ call _cphlde\ call z,createdown
 ld hl,(beat)\ ld de,394\ call _cphlde\ call z,createup
 ld hl,(beat)\ ld de,404\ call _cphlde\ call z,createfoot
 ld hl,(beat)\ ld de,414\ call _cphlde\ call z,createfoot
 ret

clearfootcheatflag:
 xor a
 ld (footcheatflag),a
 ret

clearleftcheatflag:
 xor a
 ld (leftcheatflag),a
 jp ldret

clearupcheatflag:
 xor a
 ld (upcheatflag),a
 jp ldret

cleardowncheatflag:
 xor a
 ld (downcheatflag),a
 jp ldret

clearrightcheatflag:
 xor a
 ld (rightcheatflag),a
 jp ldret

doleft:
 bit 1,a
 jr nz,clearleftcheatflag

checkleft:
 ld a,(leftcheatflag)
 or a
 jp nz,ldret
 ld hl,leftsave
 ld (tempword1),hl
 ld b,12
checkleftloop:
 ld a,b
 ld (tempbyte),a
 ld hl,(tempword1)
 ld a,(hl)
 or a
 call nz,checkleftreal
 ld hl,(tempword1)
 inc hl\ inc hl
 ld (tempword1),hl
 ld a,(tempbyte)
 ld b,a
 djnz checkleftloop
 ld a,1
 ld (leftcheatflag),a
 ld a,(tempbyte2)
 ret

checkleftreal:
 inc hl
 ld a,(hl)
 cp 14
 jr z,gotleftbad
 cp 13
 jr z,gotleftgood
 cp 12
 jr z,gotleftperfect
 cp 11
 jr z,gotleftgood
 cp 10
 jr z,gotleftbad
 ret

gotleftperfect:
 call killleft
 jp incscore200

gotleftgood:
 call killleft
 jp incscore100

gotleftbad:
 call killleft
 jp incscore50

doup:
 bit 3,a
 jp nz,clearupcheatflag

checkup:
 ld a,(upcheatflag)
 or a
 jp nz,ldret
 ld hl,upsave
 ld (tempword1),hl
 ld b,12
checkuploop:
 ld a,b
 ld (tempbyte),a
 ld hl,(tempword1)
 ld a,(hl)
 or a
 call nz,checkupreal
 ld hl,(tempword1)
 inc hl\ inc hl
 ld (tempword1),hl
 ld a,(tempbyte)
 ld b,a
 djnz checkuploop
 ld a,1
 ld (upcheatflag),a
 ld a,(tempbyte2)
 ret

checkupreal:
 inc hl
 ld a,(hl)
 cp 14
 jr z,gotupbad
 cp 13
 jr z,gotupgood
 cp 12
 jr z,gotupperfect
 cp 11
 jr z,gotupgood
 cp 10
 jr z,gotupbad
 ret

gotupperfect:
 call killup
 jp incscore200

gotupgood:
 call killup
 jp incscore100

gotupbad:
 call killup
 jp incscore50

dofoot:
 bit 5,a
 jp nz,clearfootcheatflag

checkfoot:
 ld a,(footcheatflag)
 or a
 jp nz,ldret
 ld hl,footsave
 ld (tempword1),hl
 ld b,12
checkfootloop:
 ld a,b
 ld (tempbyte),a
 ld hl,(tempword1)
 ld a,(hl)
 or a
 call nz,checkfootreal
 ld hl,(tempword1)
 inc hl\ inc hl
 ld (tempword1),hl
 ld a,(tempbyte)
 ld b,a
 djnz checkfootloop
 ld a,1
 ld (footcheatflag),a
 ret

checkfootreal:
 inc hl
 ld a,(hl)
 cp 14
 jr z,gotfootbad
 cp 13
 jr z,gotfootgood
 cp 12
 jr z,gotfootperfect
 cp 11
 jr z,gotfootgood
 cp 10
 jr z,gotfootbad
 ret

gotfootperfect:
 call killfoot
 jp incscore200

gotfootgood:
 call killfoot
 jp incscore100

gotfootbad:
 call killfoot
 jp incscore50

dodown:
 bit 0,a
 jp nz,cleardowncheatflag

checkdown:
 ld a,(downcheatflag)
 or a
 jp nz,ldret
 ld hl,downsave
 ld (tempword1),hl
 ld b,12
checkdownloop:
 ld a,b
 ld (tempbyte),a
 ld hl,(tempword1)
 ld a,(hl)
 or a
 call nz,checkdownreal
 ld hl,(tempword1)
 inc hl\ inc hl
 ld (tempword1),hl
 ld a,(tempbyte)
 ld b,a
 djnz checkdownloop
 ld a,1
 ld (downcheatflag),a
 ld a,(tempbyte2)
 ret

checkdownreal:
 inc hl
 ld a,(hl)
 cp 14
 jr z,gotdownbad
 cp 13
 jr z,gotdowngood
 cp 12
 jr z,gotdownperfect
 cp 11
 jr z,gotdowngood
 cp 10
 jr z,gotdownbad
 ret

gotdownperfect:
 call killdown
 jp incscore200

gotdowngood:
 call killdown
 jp incscore100

gotdownbad:
 call killdown
 jp incscore50

doright:
 bit 2,a
 jp nz,clearrightcheatflag

checkright:
 ld a,(rightcheatflag)
 or a
 jp nz,ldret
 ld hl,rightsave
 ld (tempword1),hl
 ld b,12
checkrightloop:
 ld a,b
 ld (tempbyte),a
 ld hl,(tempword1)
 ld a,(hl)
 or a
 call nz,checkrightreal
 ld hl,(tempword1)
 inc hl\ inc hl
 ld (tempword1),hl
 ld a,(tempbyte)
 ld b,a
 djnz checkrightloop
 ld a,1
 ld (rightcheatflag),a
 ld a,(tempbyte2)
 ret

checkrightreal:
 inc hl
 ld a,(hl)
 cp 14
 jr z,gotrightbad
 cp 13
 jr z,gotrightgood
 cp 12
 jr z,gotrightperfect
 cp 11
 jr z,gotrightgood
 cp 10
 jr z,gotrightbad
 ret

gotrightperfect:
 call killright
 jp incscore200

gotrightgood:
 call killright
 jp incscore100

gotrightbad:
 call killright
 jp incscore50

ldret:
 ld a,(tempbyte2)
 ret

incbeat:
 ld hl,(beat)
 inc hl
 ld (beat),hl
 ret

moveall:
 call moveleft
 call moveup
 call movefoot
 call movedown
; jr moveright

moveright:
 ld hl,rightsave
 ld (tempword1),hl
 ld b,12
moverightloop:
 ld a,b
 ld (tempbyte),a
 ld hl,(tempword1)
 ld a,(hl)
 or a
 call nz,moverightreal
 ld hl,(tempword1)
 inc hl\ inc hl
 ld (tempword1),hl
 ld a,(tempbyte)
 ld b,a
 djnz moverightloop
 ret

moverightreal:
 inc hl         ; Y coordinate
 ld a,(hl)      ; If Y == 0, goto killright
 or a
 jr z,killright
 call drawright ; Erase right bitmap
 ld hl,(tempword1)
 inc hl
 dec (hl)
 jr drawright

killright:
 dec hl
 ld (hl),0
 inc hl
 jr drawright

createright:
 ld hl,rightsave
 ld b,12
createrightloop:
 ld a,(hl)
 or a
 jr z,createrightreal
 inc hl\ inc hl
 djnz createrightloop
 ret

createrightreal:
 ld (hl),1
 inc hl
 ld (hl),56

drawright:       ; hl = Y coordinate
 ld a,(hl)
 ld e,a
 ld a,82
 ld hl,right
 jp PutSprite

moveup:
 ld hl,upsave
 ld (tempword1),hl
 ld b,12
moveuploop:
 ld a,b
 ld (tempbyte),a
 ld hl,(tempword1)
 ld a,(hl)
 or a
 call nz,moveupreal
 ld hl,(tempword1)
 inc hl\ inc hl
 ld (tempword1),hl
 ld a,(tempbyte)
 ld b,a
 djnz moveuploop
 ret

moveupreal:
 inc hl         ; Y coordinate
 ld a,(hl)      ; If Y == 0, goto killup
 or a
 jr z,killup
 call drawup    ; Erase up bitmap
 ld hl,(tempword1)
 inc hl
 dec (hl)
 jr drawup

killup:
 dec hl
 ld (hl),0
 inc hl
 jr drawup

createup:
 ld hl,upsave
 ld b,12
createuploop:
 ld a,(hl)
 or a
 jr z,createupreal
 inc hl\ inc hl
 djnz createuploop
 ret

createupreal:
 ld (hl),1
 inc hl
 ld (hl),56

drawup:       ; hl = Y coordinate
 ld a,(hl)
 ld e,a
 ld a,46
 ld hl,up
 jp PutSprite

movefoot:
 ld hl,footsave
 ld (tempword1),hl
 ld b,12
movefootloop:
 ld a,b
 ld (tempbyte),a
 ld hl,(tempword1)
 ld a,(hl)
 or a
 call nz,movefootreal
 ld hl,(tempword1)
 inc hl\ inc hl
 ld (tempword1),hl
 ld a,(tempbyte)
 ld b,a
 djnz movefootloop
 ret

movefootreal:
 inc hl         ; Y coordinate
 ld a,(hl)      ; If Y == 0, goto killfoot
 or a
 jr z,killfoot
 call drawfoot  ; Erase foot bitmap
 ld hl,(tempword1)
 inc hl
 dec (hl)
 jr drawfoot

killfoot:
 dec hl
 ld (hl),0
 inc hl
 jr drawfoot

createfoot:
 ld hl,footsave
 ld b,12
createfootloop:
 ld a,(hl)
 or a
 jr z,createfootreal
 inc hl\ inc hl
 djnz createfootloop
 ret

createfootreal:
 ld (hl),1
 inc hl
 ld (hl),56

drawfoot:       ; hl = Y coordinate
 ld a,(hl)
 ld e,a
 ld a,58
 ld hl,foot
 jp PutSprite

movedown:
 ld hl,downsave
 ld (tempword1),hl
 ld b,12
movedownloop:
 ld a,b
 ld (tempbyte),a
 ld hl,(tempword1)
 ld a,(hl)
 or a
 call nz,movedownreal
 ld hl,(tempword1)
 inc hl\ inc hl
 ld (tempword1),hl
 ld a,(tempbyte)
 ld b,a
 djnz movedownloop
 ret

movedownreal:
 inc hl         ; Y coordinate
 ld a,(hl)      ; If Y == 0, goto killdown
 or a
 jr z,killdown
 call drawdown  ; Erase down bitmap
 ld hl,(tempword1)
 inc hl
 dec (hl)
 jr drawdown

killdown:
 dec hl
 ld (hl),0
 inc hl
 jr drawdown

createdown:
 ld hl,downsave
 ld b,12
createdownloop:
 ld a,(hl)
 or a
 jr z,createdownreal
 inc hl\ inc hl
 djnz createdownloop
 ret

createdownreal:
 ld (hl),1
 inc hl
 ld (hl),56

drawdown:       ; hl = Y coordinate
 ld a,(hl)
 ld e,a
 ld a,70
 ld hl,down
 jp PutSprite

moveleft:
 ld hl,leftsave
 ld (tempword1),hl
 ld b,12
moveleftloop:
 ld a,b
 ld (tempbyte),a
 ld hl,(tempword1)
 ld a,(hl)
 or a
 call nz,moveleftreal
 ld hl,(tempword1)
 inc hl\ inc hl
 ld (tempword1),hl
 ld a,(tempbyte)
 ld b,a
 djnz moveleftloop
 ret

moveleftreal:
 inc hl         ; Y coordinate
 ld a,(hl)      ; If Y == 0, goto killleft
 or a
 jr z,killleft
 call drawleft  ; Erase left bitmap
 ld hl,(tempword1)
 inc hl
 dec (hl)
 jr drawleft

killleft:
 dec hl
 ld (hl),0
 inc hl
 jr drawleft

createleft:
 ld hl,leftsave
 ld b,12
createleftloop:
 ld a,(hl)
 or a
 jr z,realcreateleft
 inc hl\ inc hl
 djnz createleftloop
 ret

realcreateleft:
 ld (hl),1
 inc hl
 ld (hl),56

drawleft:       ; hl = Y coordinate
 ld a,(hl)
 ld e,a
 ld a,34
 ld hl,left
 jp PutSprite

dispscore:
 ld hl,$1006
 ld (_curRow),hl
 ld hl,(score)
 jp DispHL

copytoscreen:
 ld hl,_plotSScreen
 ld (tempword1),hl
 ld hl,$fc00
 ld (tempword2),hl
 ld b,64
copytoloop:
 ld a,b
 ld (tempbyte),a
 ld hl,(tempword1)
 ld de,(tempword2)
 ld bc,12
 ldir
 call incall
 ld a,(tempbyte)
 ld b,a
 djnz copytoloop
 ret

incall:
 ld de,16
 ld hl,(tempword1)
 add hl,de
 ld (tempword1),hl
 ld hl,(tempword2)
 add hl,de
 ld (tempword2),hl
 ret

incscore200:
 ld hl,(score)
 ld de,200
 add hl,de
 ld (score),hl
 jr dispscore

incscore100:
 ld hl,(score)
 ld de,100
 add hl,de
 ld (score),hl
 jr dispscore

incscore50:
 ld hl,(score)
 ld de,50
 add hl,de
 ld (score),hl
 jr dispscore

wait:
 ld a,(delay)
 or a
 ret z
 ld b,a
waitloop:
 halt
 djnz waitloop
 ret

;----Sprites----;
left:
 .db %00011100
 .db %00111000
 .db %01110000
 .db %11111111
 .db %11111111
 .db %01110000
 .db %00111000
 .db %00011100

up:
 .db %00011000
 .db %00111100
 .db %01111110
 .db %11111111
 .db %11011011
 .db %10011001
 .db %00011000
 .db %00011000

down:
 .db %00011000
 .db %00011000
 .db %10011001
 .db %11011011
 .db %11111111
 .db %01111110
 .db %00111100
 .db %00011000

right:
 .db %00111000
 .db %00011100
 .db %00001110
 .db %11111111
 .db %11111111
 .db %00001110
 .db %00011100
 .db %00111000

foot:
 .db %01111110
 .db %10000001
 .db %10100101
 .db %10000001
 .db %10100101
 .db %10011001
 .db %10000001
 .db %01111110

;----Inits----;
ddcinit:
 call _runindicoff
 im 1          ;This is where we fix the down-left freeze
 ld hl,$D400   ;I didn't make this code, I got this from Hoverbug!
 ld de,$D401
 ld bc,$0100
 ld (hl),$D3
 ldir
 ld hl,int_handler
 ld de,$D3D3
 ld bc,int_end-int_handler
 ldir
 ld a,$D4
 ld i,a
 im 2
 jr donepatch

int_handler:
 ex af,af'
 ld a,($C1B4)   ;_CXCURAPP
 cp $1D
 jr c,int_ok
 cp $20
 jr nc,int_ok
 im 1
 jp $0039
int_ok:
 in a,($03)
 bit 3,a
 jp z,$0039
 res 0,a
 out ($03),a
 jp $0039
int_end:
donepatch:  ;We have just fixed it!
 call _flushallmenus
 call _clrScrn
 call graphbufclear
 res appTextSave,(iy + appflags)
 call varinit
 call chooselevel
 ld a,(exitz)\ or a\ jp nz,exit
 call choosespeed\ call _clrLCD
 ld a,(exitz)\ or a\ jp nz,exit

;----Init Calls----;
screeninit:
 ld hl,left
 ld a,34
 ld e,12
 call PutSprite
 ld hl,up
 ld a,46
 ld e,12
 call PutSprite
 ld hl,foot
 ld a,58
 ld e,12
 call PutSprite
 ld hl,down
 ld a,70
 ld e,12
 call PutSprite
 ld hl,right
 ld a,82
 ld e,12
 call PutSprite
 ld hl,$1005
 ld (_curRow),hl
 ld hl,scorestr
 call _puts
 jp dispscore

choosespeed:
 call _clrLCD
 ld hl,titlestr
 ld bc,4
 ld (_penCol),bc
 call _vputs
 ld hl,pressf1f4str
 ld bc,12 + (256 * 48)
 ld (_penCol),bc
 call _vputs
 ld hl,f1f4str
 ld bc,29 + (256 * 55)
 ld (_penCol),bc
 call _vputs
choosespeedloop:
 call _get_key
 cp K_EXIT
 jp z,exit1
 cp K_F1
 jr z,speedf1
 cp K_F2
 jr z,speedf2
 cp K_F3
 jr z,speedf3
 cp K_F4
 jr z,speedf4
 cp K_F5
 jr z,speedf5
 halt\ halt\ halt
 jr choosespeedloop

speedf1:
 ld a,1
 ld (delay),a
 ret

speedf2:
 ld a,2
 ld (delay),a
 ret

speedf3:
 ld a,3
 ld (delay),a
 ret

speedf4:
 ld a,4
 ld (delay),a
 ret

speedf5:
 ld a,5
 ld (delay),a
 ret

chooselevel:
 ld hl,ddctitlescreen
 ld de,$fc20
 ld bc,413
 ldir
 ld hl,versionstr
 ld bc,$1c2f
 ld (_penCol),bc
 call _vputs
 ld hl,programmedbystr
 ld bc,$2314
 ld (_penCol),bc
 call _vputs
 ld hl,ddclevelstr
 ld bc,1 + (256*48)
 ld (_penCol),bc
 call _vputs
chooselevelloop:
 call _get_key
 cp K_SECOND
 jr z,lvlcommit
 cp K_ENTER
 jr z,lvlcommit
 cp K_EXIT
 jp z,exit1
 halt\ halt\ halt
 jr chooselevelloop

lvlcommit:
 ret

ddctitlescreen:
 .db $00,$00,$00,$00,$00,$1f,$c0,$00,$0f,$e0,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$3f,$c0,$00,$1f,$e0,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$3f,$c0,$00,$1f,$e0,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$1f,$c0,$00,$0f,$e0,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$03,$c0,$00,$01,$e0,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$03,$c0,$00,$01,$e0,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$03,$c0,$00,$01,$e0,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$03,$c0,$00,$01,$e0,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$0f,$e3,$c0,$07,$f1,$e0,$01,$ff,$30,$00,$00,$00
 .db $00,$00,$00,$00,$3f,$fb,$c0,$1f,$fd,$e0,$07,$ff,$f8,$00,$00,$00
 .db $00,$00,$00,$00,$ff,$ff,$c0,$7f,$ff,$e0,$1f,$ff,$f8,$00,$00,$00
 .db $00,$00,$00,$01,$ff,$ff,$c0,$ff,$ff,$e0,$3f,$ff,$f8,$00,$00,$00
 .db $00,$00,$00,$03,$f8,$3f,$c1,$fc,$1f,$e0,$7f,$03,$f8,$00,$00,$00
 .db $00,$00,$00,$03,$e0,$0f,$c1,$f0,$07,$e0,$7c,$00,$f8,$00,$00,$00
 .db $00,$00,$00,$07,$c0,$07,$c3,$e0,$03,$e0,$f8,$00,$78,$00,$00,$00
 .db $00,$00,$00,$07,$80,$03,$c3,$c0,$01,$e0,$f0,$00,$70,$00,$00,$00
 .db $00,$00,$00,$07,$80,$03,$c3,$c0,$01,$e0,$f0,$00,$00,$00,$00,$00
 .db $00,$00,$00,$07,$80,$03,$c3,$c0,$01,$e0,$f0,$00,$00,$00,$00,$00
 .db $00,$00,$00,$07,$80,$03,$c3,$c0,$01,$e0,$f0,$00,$00,$00,$00,$00
 .db $00,$00,$00,$07,$c0,$07,$c3,$e0,$03,$e0,$f8,$00,$18,$00,$00,$00
 .db $00,$00,$00,$03,$c0,$07,$c1,$e0,$03,$e0,$78,$00,$3c,$00,$00,$00
 .db $00,$00,$00,$03,$f0,$1f,$c1,$f8,$0f,$e0,$7e,$00,$fc,$00,$00,$00
 .db $00,$00,$00,$01,$ff,$ff,$f8,$ff,$ff,$fc,$3f,$ff,$fc,$00,$00,$00
 .db $00,$00,$00,$00,$ff,$ff,$fc,$7f,$ff,$fe,$1f,$ff,$f8,$00,$00,$00
 .db $00,$00,$00,$00,$7f,$fb,$fc,$3f,$fd,$fe,$0f,$ff,$e0,$00,$00,$00
 .db $00,$00,$00,$00,$0f,$e3,$f8,$07,$f1,$fc,$01,$ff,$80

varinit:
 ld hl,0
 ld (score),hl
 ld (beat),hl
 xor a
 ld (exitz),a
 ld (leftcheatflag),a
 ld (upcheatflag),a
 ld (footcheatflag),a
 ld (downcheatflag),a
 ld (rightcheatflag),a
 ld hl,leftsave
 call clearsave
 ld hl,upsave
 call clearsave
 ld hl,footsave
 call clearsave
 ld hl,downsave
 call clearsave
 ld hl,rightsave

clearsave:
 ld b,12
clearsaveloop:
 ld (hl),0
 inc hl\ inc hl
 djnz clearsaveloop
 ret

graphbufclear:
 ld hl,_plotSScreen
 ld de,_plotSScreen + 1
 ld bc,1024
 ld (hl),0
 ldir
 set graphdraw,(iy + graphflags)
 ret

exit1:
 ld a,1
 ld (exitz),a
 ret

exitback:
 ld b,10
loopitt:
 halt\ halt
 djnz loopitt
 jp ProgStart

exit:
 set appTextSave,(iy + appflags)
 call _homeup
 jp _clrScrn

;I got this from Ahmed's Archery game.  (Modified)
;|This Routine was converted by AVD from Movax's 83
;|Special thanks to ScaBBy for making it XOR Routine!
PutSprite:
       push    hl
        ld      hl,0
        ld      d,0
 ex de,hl
 add hl,hl
 add hl,hl
 add hl,hl
 add hl,hl

        ld      d,0
        ld      e,a
        srl     e
        srl     e
        srl     e
        add     hl,de

        ld      de,_plotSScreen
        add     hl,de

        ld      b,%00000111
        and     b
        cp 0
        jp      z,ALIGN
        pop     ix
        ld      d,a

        ld      e,8
LILOP:  ld      b,(ix+0)

        ld      c,0
        push    de
SHLOP:  srl     b
        rr      c
        dec     d
        jp      nz,SHLOP
        pop     de

        ld      a,b
        xor     (hl)
        ld      (hl),a
        inc     hl
        ld      a,c
        xor     (hl)
        ld      (hl),a

        ld      bc,15
        add     hl,bc
        inc     ix

        dec     e
        jp      nz,LILOP

        jp      DONE1
ALIGN:
        pop     de
        ld      b,8
ALOP1:  ld      a,(de)
        xor      (hl)
        ld      (hl),a
        inc     de
        push    bc
        ld      bc,16
        add     hl,bc
        pop     bc
        djnz    ALOP1

DONE1:
        ret



;----Display routine----; By Mathew Shepcar
DispA:
 ld l,a
 ld h,0
DispHL:
 xor a
 ld de,-1
 ld (_penRow),de
 call $4a33
 dec hl
 jp _puts

;----Strings----;
titlestr: .db "Dance - Dance - Revolution for TI - 86",0
versionstr: .db "Version .35",0
programmedbystr: .db "Programmed by Garam Song",0
ddclevelstr: .db "ddc level -",0
pressf1f4str: .db "Press [f1] - [f5] to choose speed",0
f1f4str: .db "[f1] - fast, [f5] - slow",0
scorestr: .db "SCORE",0

.end